var HistorySubmenus2 = {
	placesBundle: Components.classes["@mozilla.org/intl/stringbundle;1"].
			getService(Components.interfaces.nsIStringBundleService).
					createBundle("chrome://places/locale/places.properties"),
	dateFormatBundle: Components.classes["@mozilla.org/intl/stringbundle;1"].
			getService(Components.interfaces.nsIStringBundleService).
					createBundle("chrome://global/locale/dateFormat.properties"),

	prefService: Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefService).getBranch("extensions.HistorySubmenus2@Merci.chao."),
	dateService: Components.classes["@mozilla.org/intl/scriptabledateformat;1"].
			getService(Components.interfaces.nsIScriptableDateFormat),
	get locale() Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefService).getCharPref("general.useragent.locale"),

	formatToken: {
		year: "%y",
		yearL: "%Y",
		month: "%m",
		monthL: "%M",
		date: "%d",
		dateL: "%D",
		monthName: "%n",
		monthNameL: "%N",
		weekDay: "%w",
		weekDayL: "%W",
		weekDay2: "%k",
		weekDay2L: "%K",
		age: "%a"
	},

	formatDate: function(day, string) {
		let f = this.formatToken;
		let placesBundle = this.placesBundle;
		let dateFormatBundle = this.dateFormatBundle;

		let year = new String(day.getFullYear());
		let month = day.getMonth() + 1;
		let monthName = dateFormatBundle.GetStringFromName("month." + month + ".Mmm");
		let monthNameL = dateFormatBundle.GetStringFromName("month." + month + ".name");
		let date = day.getDate();
		let weekDay = this.dateService.FormatDate(this.locale, this.dateService.dateFormatWeekday,
				year, month, date);
		let weekDayL = dateFormatBundle.GetStringFromName("day." + (day.getDay() + 1) + ".name");
		let weekDay2 = dateFormatBundle.GetStringFromName("day." + (day.getDay() + 1) + ".short");
		let weekDay2L = dateFormatBundle.GetStringFromName("day." + (day.getDay() + 1) + ".Mmm");

		let age = (this.getStartOfDate(new Date()) - this.getStartOfDate(day)) / 1000 / 60 / 60 / 24;
		if (age < 2)
			age = placesBundle.GetStringFromName("finduri-AgeInDays-is-" + age);
		else
			age = placesBundle.formatStringFromName("finduri-AgeInDays-is", [age], 1);

		string = string.replace(new RegExp(f.year, "g"), year.substring(year.length - 2));
		string = string.replace(new RegExp(f.yearL, "g"), year);
		string = string.replace(new RegExp(f.month, "g"), month);
		string = string.replace(new RegExp(f.monthL, "g"), month < 10 ? "0" + month : month);
		string = string.replace(new RegExp(f.date, "g"), date);
		string = string.replace(new RegExp(f.dateL, "g"), date < 10 ? "0" + date : date);
		string = string.replace(new RegExp(f.weekDay, "g"), weekDay);
		string = string.replace(new RegExp(f.weekDayL, "g"), weekDayL);
		string = string.replace(new RegExp(f.weekDay2, "g"), weekDay2);
		string = string.replace(new RegExp(f.weekDay2L, "g"), weekDay2L);
		string = string.replace(new RegExp(f.monthName, "g"), monthName);
		string = string.replace(new RegExp(f.monthNameL, "g"), monthNameL);
		string = string.replace(new RegExp(f.age, "g"), age);

		return string;
	},

	getStartOfDate: function(date) {
		date = new Date(date.getTime());

		date.setHours(0);
		date.setMinutes(0);
		date.setSeconds(0);
		date.setMilliseconds(0);

		return date;
	}
};